--- /dev/null
+++ net/minecraft/src/DataWatcher.java
@@ -1,0 +1,179 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.Iterator;
+import java.util.List;
+import java.util.Map;
+
+public class DataWatcher {
+	private static final HashMap dataTypes = new HashMap();
+	private final Map watchedObjects = new HashMap();
+	private boolean objectChanged;
+
+	public void addObject(int var1, Object var2) {
+		Integer var3 = (Integer)dataTypes.get(var2.getClass());
+		if(var3 == null) {
+			throw new IllegalArgumentException("Unknown data type: " + var2.getClass());
+		} else if(var1 > 31) {
+			throw new IllegalArgumentException("Data value id is too big with " + var1 + "! (Max is " + 31 + ")");
+		} else if(this.watchedObjects.containsKey(Integer.valueOf(var1))) {
+			throw new IllegalArgumentException("Duplicate id value for " + var1 + "!");
+		} else {
+			WatchableObject var4 = new WatchableObject(var3.intValue(), var1, var2);
+			this.watchedObjects.put(Integer.valueOf(var1), var4);
+		}
+	}
+
+	public byte getWatchableObjectByte(int var1) {
+		return ((Byte)((WatchableObject)this.watchedObjects.get(Integer.valueOf(var1))).getObject()).byteValue();
+	}
+
+	public int getWatchableObjectInt(int var1) {
+		return ((Integer)((WatchableObject)this.watchedObjects.get(Integer.valueOf(var1))).getObject()).intValue();
+	}
+
+	public String getWatchableObjectString(int var1) {
+		return (String)((WatchableObject)this.watchedObjects.get(Integer.valueOf(var1))).getObject();
+	}
+
+	public void updateObject(int var1, Object var2) {
+		WatchableObject var3 = (WatchableObject)this.watchedObjects.get(Integer.valueOf(var1));
+		if(!var2.equals(var3.getObject())) {
+			var3.setObject(var2);
+			var3.setWatching(true);
+			this.objectChanged = true;
+		}
+
+	}
+
+	public static void writeObjectsInListToStream(List var0, DataOutputStream var1) throws IOException {
+		if(var0 != null) {
+			Iterator var2 = var0.iterator();
+
+			while(var2.hasNext()) {
+				WatchableObject var3 = (WatchableObject)var2.next();
+				writeWatchableObject(var1, var3);
+			}
+		}
+
+		var1.writeByte(127);
+	}
+
+	public void writeWatchableObjects(DataOutputStream var1) throws IOException {
+		Iterator var2 = this.watchedObjects.values().iterator();
+
+		while(var2.hasNext()) {
+			WatchableObject var3 = (WatchableObject)var2.next();
+			writeWatchableObject(var1, var3);
+		}
+
+		var1.writeByte(127);
+	}
+
+	private static void writeWatchableObject(DataOutputStream var0, WatchableObject var1) throws IOException {
+		int var2 = (var1.getObjectType() << 5 | var1.getDataValueId() & 31) & 255;
+		var0.writeByte(var2);
+		switch(var1.getObjectType()) {
+		case 0:
+			var0.writeByte(((Byte)var1.getObject()).byteValue());
+			break;
+		case 1:
+			var0.writeShort(((Short)var1.getObject()).shortValue());
+			break;
+		case 2:
+			var0.writeInt(((Integer)var1.getObject()).intValue());
+			break;
+		case 3:
+			var0.writeFloat(((Float)var1.getObject()).floatValue());
+			break;
+		case 4:
+			Packet.writeString((String)var1.getObject(), var0);
+			break;
+		case 5:
+			ItemStack var4 = (ItemStack)var1.getObject();
+			var0.writeShort(var4.getItem().shiftedIndex);
+			var0.writeByte(var4.stackSize);
+			var0.writeShort(var4.getItemDamage());
+			break;
+		case 6:
+			ChunkCoordinates var3 = (ChunkCoordinates)var1.getObject();
+			var0.writeInt(var3.x);
+			var0.writeInt(var3.y);
+			var0.writeInt(var3.z);
+		}
+
+	}
+
+	public static List readWatchableObjects(DataInputStream var0) throws IOException {
+		ArrayList var1 = null;
+
+		for(byte var2 = var0.readByte(); var2 != 127; var2 = var0.readByte()) {
+			if(var1 == null) {
+				var1 = new ArrayList();
+			}
+
+			int var3 = (var2 & 224) >> 5;
+			int var4 = var2 & 31;
+			WatchableObject var5 = null;
+			switch(var3) {
+			case 0:
+				var5 = new WatchableObject(var3, var4, Byte.valueOf(var0.readByte()));
+				break;
+			case 1:
+				var5 = new WatchableObject(var3, var4, Short.valueOf(var0.readShort()));
+				break;
+			case 2:
+				var5 = new WatchableObject(var3, var4, Integer.valueOf(var0.readInt()));
+				break;
+			case 3:
+				var5 = new WatchableObject(var3, var4, Float.valueOf(var0.readFloat()));
+				break;
+			case 4:
+				var5 = new WatchableObject(var3, var4, Packet.readString(var0, 64));
+				break;
+			case 5:
+				short var9 = var0.readShort();
+				byte var10 = var0.readByte();
+				short var11 = var0.readShort();
+				var5 = new WatchableObject(var3, var4, new ItemStack(var9, var10, var11));
+				break;
+			case 6:
+				int var6 = var0.readInt();
+				int var7 = var0.readInt();
+				int var8 = var0.readInt();
+				var5 = new WatchableObject(var3, var4, new ChunkCoordinates(var6, var7, var8));
+			}
+
+			var1.add(var5);
+		}
+
+		return var1;
+	}
+
+	public void updateWatchedObjectsFromList(List var1) {
+		Iterator var2 = var1.iterator();
+
+		while(var2.hasNext()) {
+			WatchableObject var3 = (WatchableObject)var2.next();
+			WatchableObject var4 = (WatchableObject)this.watchedObjects.get(Integer.valueOf(var3.getDataValueId()));
+			if(var4 != null) {
+				var4.setObject(var3.getObject());
+			}
+		}
+
+	}
+
+	static {
+		dataTypes.put(Byte.class, Integer.valueOf(0));
+		dataTypes.put(Short.class, Integer.valueOf(1));
+		dataTypes.put(Integer.class, Integer.valueOf(2));
+		dataTypes.put(Float.class, Integer.valueOf(3));
+		dataTypes.put(String.class, Integer.valueOf(4));
+		dataTypes.put(ItemStack.class, Integer.valueOf(5));
+		dataTypes.put(ChunkCoordinates.class, Integer.valueOf(6));
+	}
+}
--- /dev/null
+++ net/minecraft/src/Packet60Explosion.java
@@ -1,0 +1,67 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.Set;
+
+public class Packet60Explosion extends Packet {
+	public double explosionX;
+	public double explosionY;
+	public double explosionZ;
+	public float explosionSize;
+	public Set destroyedBlockPositions;
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.explosionX = var1.readDouble();
+		this.explosionY = var1.readDouble();
+		this.explosionZ = var1.readDouble();
+		this.explosionSize = var1.readFloat();
+		int var2 = var1.readInt();
+		this.destroyedBlockPositions = new HashSet();
+		int var3 = (int)this.explosionX;
+		int var4 = (int)this.explosionY;
+		int var5 = (int)this.explosionZ;
+
+		for(int var6 = 0; var6 < var2; ++var6) {
+			int var7 = var1.readByte() + var3;
+			int var8 = var1.readByte() + var4;
+			int var9 = var1.readByte() + var5;
+			this.destroyedBlockPositions.add(new ChunkPosition(var7, var8, var9));
+		}
+
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeDouble(this.explosionX);
+		var1.writeDouble(this.explosionY);
+		var1.writeDouble(this.explosionZ);
+		var1.writeFloat(this.explosionSize);
+		var1.writeInt(this.destroyedBlockPositions.size());
+		int var2 = (int)this.explosionX;
+		int var3 = (int)this.explosionY;
+		int var4 = (int)this.explosionZ;
+		Iterator var5 = this.destroyedBlockPositions.iterator();
+
+		while(var5.hasNext()) {
+			ChunkPosition var6 = (ChunkPosition)var5.next();
+			int var7 = var6.x - var2;
+			int var8 = var6.y - var3;
+			int var9 = var6.z - var4;
+			var1.writeByte(var7);
+			var1.writeByte(var8);
+			var1.writeByte(var9);
+		}
+
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_12245_a(this);
+	}
+
+	public int getPacketSize() {
+		return 32 + this.destroyedBlockPositions.size() * 3;
+	}
+}
--- /dev/null
+++ net/minecraft/src/IInvBasic.java
@@ -1,0 +1,5 @@
+package net.minecraft.src;
+
+public interface IInvBasic {
+	void func_20134_a(InventoryBasic var1);
+}
--- net/minecraft/src/EntityBoat.java
+++ net/minecraft/src/EntityBoat.java
@@ -6,6 +6,15 @@
 	public int damageTaken;
 	public int timeSinceHit;
 	public int forwardDirection;
+	private int lerpSteps;
+	private double lerpX;
+	private double lerpY;
+	private double lerpZ;
+	private double lerpYaw;
+	private double lerpPitch;
+	private double lerpVelocityX;
+	private double lerpVelocityY;
+	private double lerpVelocityZ;
 
 	public EntityBoat(World var1) {
 		super(var1);
@@ -41,11 +50,17 @@
 		this.prevPosZ = var6;
 	}
 
+	protected void entityInit() {
+	}
+
 	public double getMountedYOffset() {
 		return (double)this.height * 0.0D - (double)0.3F;
 	}
 
 	public boolean attackEntityFrom(Entity var1, int var2) {
+		if(var1.worldObj.multiplayerWorld)
+			return true;
+		
 		this.forwardDirection = -this.forwardDirection;
 		this.timeSinceHit = 10;
 		this.damageTaken += var2 * 10;
@@ -64,11 +79,37 @@
 
 		return true;
 	}
+	
+	public void performHurtAnimation() {
+		this.forwardDirection = -this.forwardDirection;
+		this.timeSinceHit = 10;
+		this.damageTaken += 10;
+	}
 
 	public boolean canBeCollidedWith() {
 		return !this.isDead;
 	}
 
+	@Override
+	public void setPositionAndRotation(double x, double y, double z, float yaw, float pitch, int steps) {
+		this.lerpX = x;
+		this.lerpY = y;
+		this.lerpZ = z;
+		this.lerpYaw = yaw;
+		this.lerpPitch = pitch;
+		this.lerpSteps = steps + 4;
+		this.motionX = this.lerpVelocityX;
+		this.motionY = this.lerpVelocityY;
+		this.motionZ = this.lerpVelocityZ;
+	}
+
+	@Override
+	public void setVelocity(double velocityX, double velocityY, double velocityZ) {
+		this.lerpVelocityX = this.motionX = velocityX;
+		this.lerpVelocityY = this.motionY = velocityY;
+		this.lerpVelocityZ = this.motionZ = velocityZ;
+	}
+
 	public void onUpdate() {
 		super.onUpdate();
 		if(this.timeSinceHit > 0) {
@@ -94,6 +135,44 @@
 			}
 		}
 
+		if (this.worldObj.multiplayerWorld) {
+			if (this.lerpSteps > 0) {
+				double e = this.posX + (this.lerpX - this.posX) / this.lerpSteps;
+				double m = this.posY + (this.lerpY - this.posY) / this.lerpSteps;
+				double q = this.posZ + (this.lerpZ - this.posZ) / this.lerpSteps;
+				double t = this.lerpYaw - this.rotationYaw;
+
+				while (t < -180.0) {
+					t += 360.0;
+				}
+
+				while (t >= 180.0) {
+					t -= 360.0;
+				}
+
+				this.rotationYaw = (float)(this.rotationYaw + t / this.lerpSteps);
+				this.rotationPitch = (float)(this.rotationPitch + (this.lerpPitch - this.rotationPitch) / this.lerpSteps);
+				this.lerpSteps--;
+				this.setPosition(e, m, q);
+				this.setRotation(this.rotationYaw, this.rotationPitch);
+			} else {
+				double f = this.posX + this.motionX;
+				double p = this.posY + this.motionY;
+				double t = this.posZ + this.motionZ;
+				this.setPosition(f, p, t);
+				if (this.onGround) {
+					this.motionX *= 0.5;
+					this.motionY *= 0.5;
+					this.motionZ *= 0.5;
+				}
+
+				this.motionX *= 0.99F;
+				this.motionY *= 0.95F;
+				this.motionZ *= 0.99F;
+			}
+
+			return;
+		}
 		double var23 = var2 * 2.0D - 1.0D;
 		this.motionY += (double)0.04F * var23;
 		if(this.riddenByEntity != null) {
@@ -149,7 +228,7 @@
 			}
 		}
 
-		if(this.isCollidedHorizontally && var8 > 0.15D) {
+		if(this.isCollidedHorizontally && var8 > 0.15D && !this.worldObj.multiplayerWorld) {
 			this.setEntityDead();
 
 			int var24;
@@ -225,6 +304,9 @@
 	}
 
 	public boolean interact(EntityPlayer var1) {
+		if(this.worldObj.multiplayerWorld)
+			return true;
+
 		var1.mountEntity(this);
 		return true;
 	}
--- net/minecraft/src/ItemFlintAndSteel.java
+++ net/minecraft/src/ItemFlintAndSteel.java
@@ -35,10 +35,11 @@
 		int var8 = var3.getBlockId(var4, var5, var6);
 		if(var8 == 0) {
 			var3.playSoundEffect((double)var4 + 0.5D, (double)var5 + 0.5D, (double)var6 + 0.5D, "fire.ignite", 1.0F, rand.nextFloat() * 0.4F + 0.8F);
+
 			var3.setBlockWithNotify(var4, var5, var6, Block.fire.blockID);
 		}
 
-		var1.damageItem(1);
+		var1.damageItem(1, var2);
 		return true;
 	}
 }
--- net/minecraft/src/EntitySnowball.java
+++ net/minecraft/src/EntitySnowball.java
@@ -18,6 +18,9 @@
 		this.setSize(0.25F, 0.25F);
 	}
 
+	protected void entityInit() {
+	}
+
 	public boolean isInRangeToRenderDist(double var1) {
 		double var3 = this.boundingBox.getAverageEdgeLength() * 4.0D;
 		var3 *= 64.0D;
@@ -40,6 +43,14 @@
 		this.motionY = (double)(-MathHelper.sin(this.rotationPitch / 180.0F * (float)Math.PI) * var3);
 		this.setThrowableHeading(this.motionX, this.motionY, this.motionZ, 1.5F, 1.0F);
 	}
+	
+	public EntitySnowball(World var1, double var2, double var4, double var6) {
+		super(var1);
+		this.ticksInGround = 0;
+		this.setSize(0.25F, 0.25F);
+		this.setPosition(var2, var4, var6);
+		this.yOffset = 0.0F;
+	}
 
 	public void setThrowableHeading(double var1, double var3, double var5, float var7, float var8) {
 		float var9 = MathHelper.sqrt_double(var1 * var1 + var3 * var3 + var5 * var5);
@@ -61,7 +72,22 @@
 		this.ticksInGround = 0;
 	}
 
+	@Override
+	public void setVelocity(double velocityX, double velocityY, double velocityZ) {
+		this.motionX = velocityX;
+		this.motionY = velocityY;
+		this.motionZ = velocityZ;
+		if (this.prevRotationPitch == 0.0F && this.prevRotationYaw == 0.0F) {
+			float f = MathHelper.sqrt_double(velocityX * velocityX + velocityZ * velocityZ);
+			this.prevRotationYaw = this.rotationYaw = (float)(Math.atan2(velocityX, velocityZ) * 180.0 / (float) Math.PI);
+			this.prevRotationPitch = this.rotationPitch = (float)(Math.atan2(velocityY, f) * 180.0 / (float) Math.PI);
+		}
+	}
+
 	public void onUpdate() {
+		this.prevPosX = this.posX;
+		this.prevPosY = this.posY;
+		this.prevPosZ = this.posZ;
 		super.onUpdate();
 		if(this.throwableShake > 0) {
 			--this.throwableShake;
@@ -97,37 +123,39 @@
 			var2 = Vec3D.createVector(var3.hitVec.xCoord, var3.hitVec.yCoord, var3.hitVec.zCoord);
 		}
 
-		Entity var4 = null;
-		List var5 = this.worldObj.getEntitiesWithinAABBExcludingEntity(this, this.boundingBox.addCoord(this.motionX, this.motionY, this.motionZ).expand(1.0D, 1.0D, 1.0D));
-		double var6 = 0.0D;
+		if (!this.worldObj.multiplayerWorld) {
+			Entity var4 = null;
+			List var5 = this.worldObj.getEntitiesWithinAABBExcludingEntity(this, this.boundingBox.addCoord(this.motionX, this.motionY, this.motionZ).expand(1.0D, 1.0D, 1.0D));
+			double var6 = 0.0D;
 
-		int var8;
-		float var10;
-		for(var8 = 0; var8 < var5.size(); ++var8) {
-			Entity var9 = (Entity)var5.get(var8);
-			if(var9.canBeCollidedWith() && (var9 != this.thrower || this.ticksInAir >= 5)) {
-				var10 = 0.3F;
-				AxisAlignedBB var11 = var9.boundingBox.expand((double)var10, (double)var10, (double)var10);
-				MovingObjectPosition var12 = var11.calculateIntercept(var15, var2);
-				if(var12 != null) {
-					double var13 = var15.distanceTo(var12.hitVec);
-					if(var13 < var6 || var6 == 0.0D) {
-						var4 = var9;
-						var6 = var13;
+			int var8;
+			float var10;
+			for(var8 = 0; var8 < var5.size(); ++var8) {
+				Entity var9 = (Entity)var5.get(var8);
+				if(var9.canBeCollidedWith() && (var9 != this.thrower || this.ticksInAir >= 5)) {
+					var10 = 0.3F;
+					AxisAlignedBB var11 = var9.boundingBox.expand((double)var10, (double)var10, (double)var10);
+					MovingObjectPosition var12 = var11.calculateIntercept(var15, var2);
+					if(var12 != null) {
+						double var13 = var15.distanceTo(var12.hitVec);
+						if(var13 < var6 || var6 == 0.0D) {
+							var4 = var9;
+							var6 = var13;
+						}
 					}
 				}
 			}
-		}
 
-		if(var4 != null) {
-			var3 = new MovingObjectPosition(var4);
+			if(var4 != null) {
+				var3 = new MovingObjectPosition(var4);
+			}
 		}
 
 		if(var3 != null) {
 			if(var3.entityHit != null && var3.entityHit.attackEntityFrom(this.thrower, 0)) {
 			}
 
-			for(var8 = 0; var8 < 8; ++var8) {
+			for(int var8 = 0; var8 < 8; ++var8) {
 				this.worldObj.spawnParticle("snowballpoof", this.posX, this.posY, this.posZ, 0.0D, 0.0D, 0.0D);
 			}
 
@@ -158,7 +186,7 @@
 		this.rotationPitch = this.prevRotationPitch + (this.rotationPitch - this.prevRotationPitch) * 0.2F;
 		this.rotationYaw = this.prevRotationYaw + (this.rotationYaw - this.prevRotationYaw) * 0.2F;
 		float var17 = 0.99F;
-		var10 = 0.03F;
+		float var10 = 0.03F;
 		if(this.handleWaterMovement()) {
 			for(int var18 = 0; var18 < 4; ++var18) {
 				float var19 = 0.25F;
@@ -194,7 +222,7 @@
 	}
 
 	public void onCollideWithPlayer(EntityPlayer var1) {
-		if(this.inGround && this.thrower == var1 && this.throwableShake <= 0 && var1.inventory.addItemStackToInventory(new ItemStack(Item.arrow.shiftedIndex, 1))) {
+		if(this.inGround && this.thrower == var1 && this.throwableShake <= 0 && var1.inventory.addItemStackToInventory(new ItemStack(Item.arrow.shiftedIndex, 1, 0))) {
 			this.worldObj.playSoundAtEntity(this, "random.pop", 0.2F, ((this.rand.nextFloat() - this.rand.nextFloat()) * 0.7F + 1.0F) * 2.0F);
 			var1.onItemPickup(this, 1);
 			this.setEntityDead();
--- net/minecraft/src/TileEntity.java
+++ net/minecraft/src/TileEntity.java
@@ -67,7 +67,9 @@
 	}
 
 	public void onInventoryChanged() {
-		this.worldObj.updateTileEntityChunkAndDoNothing(this.xCoord, this.yCoord, this.zCoord, this);
+		if(this.worldObj != null) {
+			this.worldObj.updateTileEntityChunkAndDoNothing(this.xCoord, this.yCoord, this.zCoord, this);
+		}
 	}
 
 	public double getDistanceFrom(double var1, double var3, double var5) {
--- /dev/null
+++ net/minecraft/src/Packet18Animation.java
@@ -1,0 +1,36 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet18Animation extends Packet {
+	public int entityId;
+	public int animate;
+
+	public Packet18Animation() {
+	}
+
+	public Packet18Animation(Entity var1, int var2) {
+		this.entityId = var1.entityID;
+		this.animate = var2;
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.entityId = var1.readInt();
+		this.animate = var1.readByte();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.entityId);
+		var1.writeByte(this.animate);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.handleArmAnimation(this);
+	}
+
+	public int getPacketSize() {
+		return 5;
+	}
+}
--- net/minecraft/src/EntityList.java
+++ net/minecraft/src/EntityList.java
@@ -94,8 +94,8 @@
 		addMapping(EntitySlime.class, "Slime", 55);
 		addMapping(EntityPig.class, "Pig", 90);
 		addMapping(EntitySheep.class, "Sheep", 91);
-		addMapping(EntityCow.class, "Cow", 91);
-		addMapping(EntityChicken.class, "Chicken", 91);
+		addMapping(EntityCow.class, "Cow", 92);
+		addMapping(EntityChicken.class, "Chicken", 93);
 		addMapping(EntityTNTPrimed.class, "PrimedTnt", 20);
 		addMapping(EntityFallingSand.class, "FallingSand", 21);
 		addMapping(EntityMinecart.class, "Minecart", 40);
--- net/minecraft/src/RecipeSorter.java
+++ net/minecraft/src/RecipeSorter.java
@@ -9,11 +9,11 @@
 		this.craftingManager = var1;
 	}
 
-	public int compareRecipes(CraftingRecipe var1, CraftingRecipe var2) {
-		return var2.getRecipeSize() < var1.getRecipeSize() ? -1 : (var2.getRecipeSize() > var1.getRecipeSize() ? 1 : 0);
+	public int compareRecipes(IRecipe var1, IRecipe var2) {
+		return var1 instanceof ShapelessRecipes && var2 instanceof ShapedRecipes ? 1 : (var2 instanceof ShapelessRecipes && var1 instanceof ShapedRecipes ? -1 : (var2.getRecipeSize() < var1.getRecipeSize() ? -1 : (var2.getRecipeSize() > var1.getRecipeSize() ? 1 : 0)));
 	}
 
 	public int compare(Object var1, Object var2) {
-		return this.compareRecipes((CraftingRecipe)var1, (CraftingRecipe)var2);
+		return this.compareRecipes((IRecipe)var1, (IRecipe)var2);
 	}
 }
--- net/minecraft/src/GuiContainer.java
+++ net/minecraft/src/GuiContainer.java
@@ -9,7 +9,16 @@
 	private static RenderItem itemRenderer = new RenderItem();
 	protected int xSize = 176;
 	protected int ySize = 166;
-	protected List inventorySlots = new ArrayList();
+	public Container inventorySlots;
+	
+	public GuiContainer(Container var1) {
+		this.inventorySlots = var1;
+	}
+
+	public void initGui() {
+		super.initGui();
+		this.mc.thePlayer.craftingInventory = this.inventorySlots;
+	}
 
 	public void drawScreen(int var1, int var2, float var3) {
 		this.drawDefaultBackground();
@@ -25,10 +34,10 @@
 		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 		GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
-		for(int var6 = 0; var6 < this.inventorySlots.size(); ++var6) {
-			SlotInventory var7 = (SlotInventory)this.inventorySlots.get(var6);
+		for(int var6 = 0; var6 < this.inventorySlots.slots.size(); ++var6) {
+			Slot var7 = (Slot)this.inventorySlots.slots.get(var6);
 			this.drawSlotInventory(var7);
-			if(var7.getIsMouseOverSlot(var1, var2)) {
+			if(this.getIsMouseOverSlot(var7, var1, var2)) {
 				GL11.glDisable(GL11.GL_LIGHTING);
 				GL11.glDisable(GL11.GL_DEPTH_TEST);
 				int var8 = var7.xDisplayPosition;
@@ -40,10 +49,10 @@
 		}
 
 		InventoryPlayer var10 = this.mc.thePlayer.inventory;
-		if(var10.draggedItemStack != null) {
+		if(var10.getItemStack() != null) {
 			GL11.glTranslatef(0.0F, 0.0F, 32.0F);
-			itemRenderer.renderItemIntoGUI(this.fontRenderer, this.mc.renderEngine, var10.draggedItemStack, var1 - var4 - 8, var2 - var5 - 8);
-			itemRenderer.renderItemOverlayIntoGUI(this.fontRenderer, this.mc.renderEngine, var10.draggedItemStack, var1 - var4 - 8, var2 - var5 - 8);
+			itemRenderer.renderItemIntoGUI(this.fontRenderer, this.mc.renderEngine, var10.getItemStack(), var1 - var4 - 8, var2 - var5 - 8);
+			itemRenderer.renderItemOverlayIntoGUI(this.fontRenderer, this.mc.renderEngine, var10.getItemStack(), var1 - var4 - 8, var2 - var5 - 8);
 		}
 
 		GL11.glDisable(GL12.GL_RESCALE_NORMAL);
@@ -61,12 +70,10 @@
 
 	protected abstract void drawGuiContainerBackgroundLayer(float var1);
 
-	private void drawSlotInventory(SlotInventory var1) {
-		IInventory var2 = var1.inventory;
-		int var3 = var1.slotIndex;
+	private void drawSlotInventory(Slot var1) {
 		int var4 = var1.xDisplayPosition;
 		int var5 = var1.yDisplayPosition;
-		ItemStack var6 = var2.getStackInSlot(var3);
+		ItemStack var6 = var1.getStack();
 		if(var6 == null) {
 			int var7 = var1.getBackgroundIconIndex();
 			if(var7 >= 0) {
@@ -83,9 +90,9 @@
 	}
 
 	private Slot getSlotAtPosition(int var1, int var2) {
-		for(int var3 = 0; var3 < this.inventorySlots.size(); ++var3) {
-			SlotInventory var4 = (SlotInventory)this.inventorySlots.get(var3);
-			if(var4.getIsMouseOverSlot(var1, var2)) {
+		for(int var3 = 0; var3 < this.inventorySlots.slots.size(); ++var3) {
+			Slot var4 = (Slot)this.inventorySlots.slots.get(var3);
+			if(this.getIsMouseOverSlot(var4, var1, var2)) {
 				return var4;
 			}
 		}
@@ -93,107 +100,31 @@
 		return null;
 	}
 
+	private boolean getIsMouseOverSlot(Slot var1, int var2, int var3) {
+		int var4 = (this.width - this.xSize) / 2;
+		int var5 = (this.height - this.ySize) / 2;
+		var2 -= var4;
+		var3 -= var5;
+		return var2 >= var1.xDisplayPosition - 1 && var2 < var1.xDisplayPosition + 16 + 1 && var3 >= var1.yDisplayPosition - 1 && var3 < var1.yDisplayPosition + 16 + 1;
+	}
+
 	protected void mouseClicked(int var1, int var2, int var3) {
 		if(var3 == 0 || var3 == 1) {
 			Slot var4 = this.getSlotAtPosition(var1, var2);
-			InventoryPlayer var5 = this.mc.thePlayer.inventory;
-			int var7;
+			int var5 = (this.width - this.xSize) / 2;
+			int var6 = (this.height - this.ySize) / 2;
+			boolean var7 = var1 < var5 || var2 < var6 || var1 >= var5 + this.xSize || var2 >= var6 + this.ySize;
+			int var8 = -1;
 			if(var4 != null) {
-				ItemStack var6 = var4.getStack();
-				if(var6 != null || var5.draggedItemStack != null) {
-					if(var6 != null && var5.draggedItemStack == null) {
-						var7 = var3 == 0 ? var6.stackSize : (var6.stackSize + 1) / 2;
-						var5.draggedItemStack = var4.inventory.decrStackSize(var4.slotIndex, var7);
-						if(var6.stackSize == 0) {
-							var4.putStack((ItemStack)null);
-						}
-
-						var4.onPickupFromSlot();
-					} else if(var6 == null && var5.draggedItemStack != null && var4.isItemValid(var5.draggedItemStack)) {
-						var7 = var3 == 0 ? var5.draggedItemStack.stackSize : 1;
-						if(var7 > var4.inventory.getInventoryStackLimit()) {
-							var7 = var4.inventory.getInventoryStackLimit();
-						}
-
-						var4.putStack(var5.draggedItemStack.splitStack(var7));
-						if(var5.draggedItemStack.stackSize == 0) {
-							var5.draggedItemStack = null;
-						}
-					} else if(var6 != null && var5.draggedItemStack != null) {
-						if(var4.isItemValid(var5.draggedItemStack)) {
-							if(var6.itemID != var5.draggedItemStack.itemID) {
-								if(var5.draggedItemStack.stackSize <= var4.inventory.getInventoryStackLimit()) {
-									var4.putStack(var5.draggedItemStack);
-									var5.draggedItemStack = var6;
-								}
-							} else if(var6.itemID == var5.draggedItemStack.itemID) {
-								if(var3 == 0) {
-									var7 = var5.draggedItemStack.stackSize;
-									if(var7 > var4.inventory.getInventoryStackLimit() - var6.stackSize) {
-										var7 = var4.inventory.getInventoryStackLimit() - var6.stackSize;
-									}
-
-									if(var7 > var5.draggedItemStack.getMaxStackSize() - var6.stackSize) {
-										var7 = var5.draggedItemStack.getMaxStackSize() - var6.stackSize;
-									}
-
-									var5.draggedItemStack.splitStack(var7);
-									if(var5.draggedItemStack.stackSize == 0) {
-										var5.draggedItemStack = null;
-									}
-
-									var6.stackSize += var7;
-								} else if(var3 == 1) {
-									var7 = 1;
-									if(var7 > var4.inventory.getInventoryStackLimit() - var6.stackSize) {
-										var7 = var4.inventory.getInventoryStackLimit() - var6.stackSize;
-									}
-
-									if(var7 > var5.draggedItemStack.getMaxStackSize() - var6.stackSize) {
-										var7 = var5.draggedItemStack.getMaxStackSize() - var6.stackSize;
-									}
-
-									var5.draggedItemStack.splitStack(var7);
-									if(var5.draggedItemStack.stackSize == 0) {
-										var5.draggedItemStack = null;
-									}
-
-									var6.stackSize += var7;
-								}
-							}
-						} else if(var6.itemID == var5.draggedItemStack.itemID && var5.draggedItemStack.getMaxStackSize() > 1) {
-							var7 = var6.stackSize;
-							if(var7 > 0 && var7 + var5.draggedItemStack.stackSize <= var5.draggedItemStack.getMaxStackSize()) {
-								var5.draggedItemStack.stackSize += var7;
-								var6.splitStack(var7);
-								if(var6.stackSize == 0) {
-									var4.putStack((ItemStack)null);
-								}
-
-								var4.onPickupFromSlot();
-							}
-						}
-					}
-				}
-
-				var4.onSlotChanged();
-			} else if(var5.draggedItemStack != null) {
-				int var9 = (this.width - this.xSize) / 2;
-				var7 = (this.height - this.ySize) / 2;
-				if(var1 < var9 || var2 < var7 || var1 >= var9 + this.xSize || var2 >= var7 + this.xSize) {
-					EntityPlayerSP var8 = this.mc.thePlayer;
-					if(var3 == 0) {
-						var8.dropPlayerItem(var5.draggedItemStack);
-						var5.draggedItemStack = null;
-					}
-
-					if(var3 == 1) {
-						var8.dropPlayerItem(var5.draggedItemStack.splitStack(1));
-						if(var5.draggedItemStack.stackSize == 0) {
-							var5.draggedItemStack = null;
-						}
-					}
-				}
+				var8 = var4.slotNumber;
+			}
+
+			if(var7) {
+				var8 = -999;
+			}
+
+			if(var8 != -1) {
+				this.mc.playerController.func_27174_a(this.inventorySlots.windowId, var8, var3, false, this.mc.thePlayer);
 			}
 		}
 
@@ -207,21 +138,27 @@
 
 	protected void keyTyped(char var1, int var2) {
 		if(var2 == 1 || var2 == this.mc.options.keyBindInventory.keyCode) {
-			this.mc.displayGuiScreen((GuiScreen)null);
+			this.mc.thePlayer.closeScreen();
 		}
 
 	}
 
 	public void onGuiClosed() {
-		InventoryPlayer var1 = this.mc.thePlayer.inventory;
-		if(var1.draggedItemStack != null) {
-			this.mc.thePlayer.dropPlayerItem(var1.draggedItemStack);
-			var1.draggedItemStack = null;
+		if(this.mc.thePlayer != null) {
+			this.mc.playerController.func_20086_a(this.inventorySlots.windowId, this.mc.thePlayer);
 		}
 
 	}
 
 	public boolean doesGuiPauseGame() {
 		return false;
+	}
+	
+	public void updateScreen() {
+		super.updateScreen();
+		if(!this.mc.thePlayer.isEntityAlive() || this.mc.thePlayer.isDead) {
+			this.mc.thePlayer.closeScreen();
+		}
+
 	}
 }
